/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20170531 (64-bit version)
 * Copyright (c) 2000 - 2017 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt6.dat, Sat Nov 11 22:28:26 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000019AA (6570)
 *     Revision         0x01
 *     Checksum         0xEB
 *     OEM ID           "APPLE "
 *     OEM Table ID     "TbtPEG11"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20100915 (537921813)
 */
DefinitionBlock ("", "SSDT", 1, "APPLE ", "TbtPEG11", 0x00001000)
{
    /*
     * iASL Warning: There were 2 external control methods found during
     * disassembly, but only 0 were resolved (2 unresolved). Additional
     * ACPI tables may be required to properly disassemble the code. This
     * resulting disassembler output file may not compile because the
     * disassembler did not know how many arguments to assign to the
     * unresolved methods. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     *
     * To specify the tables needed to resolve external control method
     * references, the -e option can be used to specify the filenames.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.PCI0, DeviceObj)
    External (_SB_.PCI0.P0P2, DeviceObj)
    External (_SB_.PCI0.PEG1, DeviceObj)
    External (BRTL, IntObj)
    External (DTGP, MethodObj)    // Warning: Unknown method, guessing 5 arguments
    External (EGPS, IntObj)
    External (GD04, UnknownObj)
    External (GD24, UnknownObj)
    External (GI04, UnknownObj)
    External (GP04, IntObj)
    External (GP23, UnknownObj)
    External (GP24, IntObj)
    External (GVNV, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (OSDW, IntObj)

    Scope (\_SB.PCI0.P0P2)
    {
        Device (GFX0)
        {
            Name (_ADR, 0x00)  // _ADR: Address
            OperationRegion (IOBR, SystemIO, 0x07C2, 0x04)
            Field (IOBR, ByteAcc, NoLock, Preserve)
            {
                BOX0,   8, 
                BOX1,   8, 
                BOX2,   8, 
                BOX3,   8
            }

            OperationRegion (DPR1, SystemIO, 0x07D0, 0x01)
            Field (DPR1, ByteAcc, NoLock, Preserve)
            {
                GRD,    8
            }

            OperationRegion (DPR2, SystemIO, 0x07D4, 0x01)
            Field (DPR2, ByteAcc, NoLock, Preserve)
            {
                GWR,    8
            }

            Method (WFRD, 0, NotSerialized)
            {
                Local0 = 0xC8
                Local1 = GWR /* \_SB_.PCI0.P0P2.GFX0.GWR_ */
                While ((Local0 && ((Local1 & 0x01) == 0x01)))
                {
                    Local2 = GRD /* \_SB_.PCI0.P0P2.GFX0.GRD_ */
                    Local1 = GWR /* \_SB_.PCI0.P0P2.GFX0.GWR_ */
                    Stall (0x64)
                    Local0--
                }

                Return ((Local0 == Zero))
            }

            Method (WFCD, 0, NotSerialized)
            {
                Local0 = 0xC8
                Local1 = GWR /* \_SB_.PCI0.P0P2.GFX0.GWR_ */
                While ((Local0 && ((Local1 & 0x01) == 0x00)))
                {
                    Local1 = GWR /* \_SB_.PCI0.P0P2.GFX0.GWR_ */
                    Stall (0x64)
                    Local0--
                }

                If ((Local1 & 0x01))
                {
                    Local2 = GRD /* \_SB_.PCI0.P0P2.GFX0.GRD_ */
                }

                Return ((Local0 == Zero))
            }

            Method (SGMX, 3, NotSerialized)
            {
                BOX0 = (0xFF & Arg2)
                If ((Arg1 >= 0x02))
                {
                    BOX1 = (0xFF & (Arg2 >> 0x08))
                }

                If ((Arg1 == 0x04))
                {
                    BOX2 = (0xFF & (Arg2 >> 0x10))
                    BOX3 = (0xFF & (Arg2 >> 0x18))
                }

                If (WFRD ()){}
                GWR = (0xFF & Arg0)
                If (WFCD ()){}
            }

            OperationRegion (EGNV, SystemMemory, GVNV (0x00020000), Field (EGNV, DWordAcc, Lock, Preserve)
                {
                    EG00,   32768, 
                    EG01,   32768, 
                    EG02,   32768, 
                    EG03,   32768, 
                    EG04,   32768, 
                    EG05,   32768, 
                    EG06,   32768, 
                    EG07,   32768, 
                    EG08,   32768, 
                    EG09,   32768, 
                    EG0A,   32768, 
                    EG0B,   32768, 
                    EG0C,   32768, 
                    EG0D,   32768, 
                    EG0E,   32768, 
                    EG0F,   32768, 
                    EG10,   32768, 
                    EG11,   32768, 
                    EG12,   32768, 
                    EG13,   32768, 
                    EG14,   32768, 
                    EG15,   32768, 
                    EG16,   32768, 
                    EG17,   32768, 
                    EG18,   32768, 
                    EG19,   32768, 
                    EG1A,   32768, 
                    EG1B,   32768, 
                    EG1C,   32768, 
                    EG1D,   32768, 
                    EG1E,   32768, 
                    EG1F,   32768
                })
            Name (VBUF, Buffer (0x1000){})
            Method (_ROM, 2, Serialized)  // _ROM: Read-Only Memory
            {
                If ((Arg0 == 0x00))
                {
                    CPVB (ToBuffer (EG00), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x1000))
                {
                    CPVB (ToBuffer (EG01), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x2000))
                {
                    CPVB (ToBuffer (EG02), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x3000))
                {
                    CPVB (ToBuffer (EG03), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x4000))
                {
                    CPVB (ToBuffer (EG04), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x5000))
                {
                    CPVB (ToBuffer (EG05), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x6000))
                {
                    CPVB (ToBuffer (EG06), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x7000))
                {
                    CPVB (ToBuffer (EG07), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x8000))
                {
                    CPVB (ToBuffer (EG08), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x9000))
                {
                    CPVB (ToBuffer (EG09), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0xA000))
                {
                    CPVB (ToBuffer (EG0A), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0xB000))
                {
                    CPVB (ToBuffer (EG0B), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0xC000))
                {
                    CPVB (ToBuffer (EG0C), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0xD000))
                {
                    CPVB (ToBuffer (EG0D), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0xE000))
                {
                    CPVB (ToBuffer (EG0E), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0xF000))
                {
                    CPVB (ToBuffer (EG0F), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x00010000))
                {
                    CPVB (ToBuffer (EG10), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x00011000))
                {
                    CPVB (ToBuffer (EG11), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x00012000))
                {
                    CPVB (ToBuffer (EG12), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x00013000))
                {
                    CPVB (ToBuffer (EG13), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x00014000))
                {
                    CPVB (ToBuffer (EG14), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x00015000))
                {
                    CPVB (ToBuffer (EG15), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x00016000))
                {
                    CPVB (ToBuffer (EG16), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x00017000))
                {
                    CPVB (ToBuffer (EG17), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x00018000))
                {
                    CPVB (ToBuffer (EG18), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x00019000))
                {
                    CPVB (ToBuffer (EG19), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x0001A000))
                {
                    CPVB (ToBuffer (EG1A), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x0001B000))
                {
                    CPVB (ToBuffer (EG1B), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x0001C000))
                {
                    CPVB (ToBuffer (EG1C), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x0001D000))
                {
                    CPVB (ToBuffer (EG1D), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x0001E000))
                {
                    CPVB (ToBuffer (EG1E), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                If ((Arg0 == 0x0001F000))
                {
                    CPVB (ToBuffer (EG1F), Arg0, Arg1)
                    Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
                }

                Return (VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
            }

            Method (CPVB, 3, Serialized)
            {
                CopyObject (Arg0, VBUF) /* \_SB_.PCI0.P0P2.GFX0.VBUF */
            }

            Name (BRTN, Package (0x12)
            {
                0x50, 
                0x2F, 
                0x00, 
                0x07, 
                0x0D, 
                0x14, 
                0x1B, 
                0x21, 
                0x28, 
                0x2F, 
                0x35, 
                0x3C, 
                0x43, 
                0x49, 
                0x50, 
                0x57, 
                0x5D, 
                0x64
            })
            Method (ABCM, 1, NotSerialized)
            {
                BRTL = Arg0
                Divide ((Arg0 * 0x03FF), 0x64, Local1, Local0)
                SGMX (0x0774, 0x04, Local0)
                Return (Zero)
            }

            Method (ABCL, 0, NotSerialized)
            {
                BRTN [0x00] = DerefOf (BRTN [0x0F])
                BRTN [0x01] = DerefOf (BRTN [0x0A])
                Return (BRTN) /* \_SB_.PCI0.P0P2.GFX0.BRTN */
            }

            Device (LCD)
            {
                Method (_ADR, 0, Serialized)  // _ADR: Address
                {
                    Return (0x8000A420)
                }

                Method (_BCL, 0, NotSerialized)  // _BCL: Brightness Control Levels
                {
                    Return (ABCL ())
                }

                Method (_BCM, 1, NotSerialized)  // _BCM: Brightness Control Method
                {
                    ABCM (Arg0)
                }

                Method (_BQC, 0, NotSerialized)  // _BQC: Brightness Query Current
                {
                    Return (BRTL) /* External reference */
                }
            }

            Method (_DOD, 0, NotSerialized)  // _DOD: Display Output Devices
            {
                Return (Package (0x01)
                {
                    0x8000A420
                })
            }

            Name (ATIB, Buffer (0x0100){})
            Method (ATIF, 2, Serialized)
            {
                If ((Arg0 == 0x00))
                {
                    Return (AF00 ())
                }

                If ((Arg0 == 0x01))
                {
                    Return (AF01 ())
                }

                If ((Arg0 == 0x02))
                {
                    Return (AF02 ())
                }
                Else
                {
                    CreateWordField (ATIB, 0x00, SSZE)
                    CreateWordField (ATIB, 0x02, VERN)
                    CreateDWordField (ATIB, 0x04, NMSK)
                    CreateDWordField (ATIB, 0x08, SFUN)
                    SSZE = 0x00
                    VERN = 0x00
                    NMSK = 0x00
                    SFUN = 0x00
                    Return (ATIB) /* \_SB_.PCI0.P0P2.GFX0.ATIB */
                }
            }

            Method (AF00, 0, NotSerialized)
            {
                CreateWordField (ATIB, 0x00, SSZE)
                CreateWordField (ATIB, 0x02, VERN)
                CreateDWordField (ATIB, 0x04, NMSK)
                CreateDWordField (ATIB, 0x08, SFUN)
                SSZE = 0x0C
                VERN = 0x01
                NMSK = 0x0C
                SFUN = 0x03
                Return (ATIB) /* \_SB_.PCI0.P0P2.GFX0.ATIB */
            }

            Method (AF01, 0, NotSerialized)
            {
                CreateWordField (ATIB, 0x00, SSZE)
                CreateDWordField (ATIB, 0x02, VMSK)
                CreateDWordField (ATIB, 0x06, FLGS)
                SSZE = 0x0A
                VMSK = 0x03
                FLGS = 0x01
                Return (ATIB) /* \_SB_.PCI0.P0P2.GFX0.ATIB */
            }

            Method (AF02, 0, NotSerialized)
            {
                CreateWordField (ATIB, 0x00, SSZE)
                CreateDWordField (ATIB, 0x02, PSBI)
                CreateByteField (ATIB, 0x06, EXPM)
                CreateByteField (ATIB, 0x07, THRM)
                CreateByteField (ATIB, 0x08, THID)
                CreateByteField (ATIB, 0x09, FPWR)
                CreateByteField (ATIB, 0x0A, FPID)
                CreateByteField (ATIB, 0x0B, SPWR)
                CreateByteField (ATIB, 0x0C, PBBL)
                SSZE = 0x0D
                PSBI = 0x08
                FPWR = 0x00
                FPID = EGPS /* External reference */
                Return (ATIB) /* \_SB_.PCI0.P0P2.GFX0.ATIB */
            }

            Name (_PRW, Package (0x02)  // _PRW: Power Resources for Wake
            {
                0x09, 
                0x03
            })
            OperationRegion (PEGH, PCI_Config, 0x00, 0x40)
            Field (PEGH, ByteAcc, NoLock, Preserve)
            {
                VID0,   16, 
                DID0,   16
            }

            OperationRegion (GBAR, SystemMemory, 0xE0008000, 0x0100)
            Field (GBAR, DWordAcc, Lock, Preserve)
            {
                Offset (0xB0), 
                    ,   4, 
                LNKD,   1, 
                Offset (0xB2), 
                    ,   4, 
                LSTS,   6, 
                    ,   1, 
                LTRN,   1
            }

            OperationRegion (C38H, SystemMemory, 0xE0008C38, 0x04)
            Field (C38H, ByteAcc, Lock, Preserve)
            {
                    ,   3, 
                CKN1,   1, 
                    ,   22, 
                CKN2,   1, 
                Offset (0x04)
            }

            OperationRegion (C20H, SystemMemory, 0xE0008C20, 0x04)
            Field (C20H, ByteAcc, Lock, Preserve)
            {
                    ,   4, 
                SQH1,   1, 
                SQH2,   1, 
                Offset (0x04)
            }

            Method (PWRD, 1, NotSerialized)
            {
                If (Arg0)
                {
                    LNKD = 0x01
                    Sleep (0x64)
                    CKN1 = 0x01
                    SQH1 = 0x00
                    SQH2 = 0x01
                    Return (0x00)
                }
                Else
                {
                    SQH1 = 0x00
                    SQH2 = 0x00
                    CKN1 = 0x00
                    LNKD = 0x00
                    While (LTRN)
                    {
                        Sleep (0x0A)
                    }

                    If ((LSTS == 0x08))
                    {
                        Return (0x00)
                    }
                    Else
                    {
                        Return (0x01)
                    }
                }
            }

            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
            {
                If ((Arg0 == ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
                {
                    If (((VID0 & 0xFFFF) != 0xFFFF))
                    {
                        Local0 = Package (0x02)
                            {
                                "hda-gfx", 
                                Buffer (0x0A)
                                {
                                    "onboard-2"
                                }
                            }
                        DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                        Return (Local0)
                    }
                }

                Return (0x80000002)
            }
        }

        Device (HDAU)
        {
            Name (_ADR, 0x01)  // _ADR: Address
            OperationRegion (HDAH, PCI_Config, 0x00, 0x40)
            Field (HDAH, ByteAcc, NoLock, Preserve)
            {
                VID0,   16, 
                DID0,   16
            }

            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
            {
                If ((Arg0 == ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
                {
                    If (((VID0 & 0xFFFF) != 0xFFFF))
                    {
                        Local0 = Package (0x02)
                            {
                                "hda-gfx", 
                                Buffer (0x0A)
                                {
                                    "onboard-2"
                                }
                            }
                        DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                        Return (Local0)
                    }
                }

                Return (0x80000002)
            }
        }
    }

    Scope (\_SB.PCI0)
    {
        Method (TGPE, 0, Serialized)
        {
            Notify (\_SB.PCI0.PEG1, 0x02) // Device Wake
        }

        Method (DTBP, 0, Serialized)
        {
            If ((\_SB.PCI0.PEG1.LDIS == 0x00))
            {
                Return (0x01)
            }

            Return (0x00)
        }

        Method (RMCR, 0, Serialized)
        {
            If (!OSDW)
            {
                If (((\_SB.PCI0.PEG1.UPSB.DSB1.UPS0.AVND == 0xFFFF) && (\_SB.PCI0.PEG1.UPSB.DSB2.UPS0.AVND == 0xFFFF)))
                {
                    Debug = "RMCR: Disable Link and Power Off Cactus Ridge Chip"
                    \_SB.PCI0.PEG1.LDIS = 0x01
                    Sleep (0x07D0)
                    GP23 = 0x00
                }
            }
        }

        Method (DTLK, 0, Serialized)
        {
            Debug = "DTLK: Dsiable Link and Power off CR going into S4/S5"
            \_SB.PCI0.PEG1.LDIS = 0x01
            Sleep (0x07D0)
            GP23 = 0x00
        }

        Scope (\_SB.PCI0.PEG1)
        {
            OperationRegion (A1E0, PCI_Config, 0x00, 0x40)
            Field (A1E0, ByteAcc, NoLock, Preserve)
            {
                AVND,   32, 
                BMIE,   3, 
                Offset (0x18), 
                PRIB,   8, 
                SECB,   8, 
                SUBB,   8, 
                Offset (0x1E), 
                    ,   13, 
                MABT,   1
            }

            OperationRegion (A1E1, PCI_Config, 0xA0, 0x40)
            Field (A1E1, ByteAcc, NoLock, Preserve)
            {
                Offset (0x01), 
                Offset (0x02), 
                Offset (0x04), 
                Offset (0x08), 
                Offset (0x0A), 
                    ,   5, 
                TPEN,   1, 
                Offset (0x0C), 
                SSPD,   4, 
                    ,   16, 
                LACR,   1, 
                Offset (0x10), 
                    ,   4, 
                LDIS,   1, 
                LRTN,   1, 
                Offset (0x12), 
                CSPD,   4, 
                    ,   7, 
                LTRN,   1, 
                    ,   1, 
                LACT,   1, 
                Offset (0x14), 
                Offset (0x30), 
                TSPD,   4
            }

            OperationRegion (A1E2, PCI_Config, 0x80, 0x08)
            Field (A1E2, ByteAcc, NoLock, Preserve)
            {
                Offset (0x01), 
                Offset (0x02), 
                Offset (0x04), 
                PSTA,   2
            }

            OperationRegion (A1E3, PCI_Config, 0x0200, 0x20)
            Field (A1E3, ByteAcc, NoLock, Preserve)
            {
                Offset (0x14), 
                Offset (0x16), 
                PSTS,   4
            }

            OperationRegion (C38H, PCI_Config, 0x0C38, 0x04)
            Field (C38H, ByteAcc, Lock, Preserve)
            {
                    ,   3, 
                CKN1,   1, 
                    ,   22, 
                CKN2,   1, 
                Offset (0x04)
            }

            OperationRegion (C20H, PCI_Config, 0x0C20, 0x04)
            Field (C20H, ByteAcc, Lock, Preserve)
            {
                    ,   4, 
                SQH1,   1, 
                SQH2,   1, 
                Offset (0x04)
            }

            Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
            {
                Return (0x00)
            }

            Device (UPSB)
            {
                Name (_ADR, 0x00)  // _ADR: Address
                OperationRegion (A1E0, PCI_Config, 0x00, 0x40)
                Field (A1E0, ByteAcc, NoLock, Preserve)
                {
                    AVND,   32, 
                    BMIE,   3, 
                    Offset (0x18), 
                    PRIB,   8, 
                    SECB,   8, 
                    SUBB,   8, 
                    Offset (0x1E), 
                        ,   13, 
                    MABT,   1
                }

                OperationRegion (A1E1, PCI_Config, 0xC0, 0x40)
                Field (A1E1, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x01), 
                    Offset (0x02), 
                    Offset (0x04), 
                    Offset (0x08), 
                    Offset (0x0A), 
                        ,   5, 
                    TPEN,   1, 
                    Offset (0x0C), 
                    SSPD,   4, 
                    Offset (0x10), 
                        ,   4, 
                    LDIS,   1, 
                    LRTN,   1, 
                        ,   23, 
                    LACT,   1, 
                    Offset (0x30), 
                    TSPD,   4
                }

                OperationRegion (A1E2, PCI_Config, 0x80, 0x08)
                Field (A1E2, ByteAcc, NoLock, Preserve)
                {
                    Offset (0x01), 
                    Offset (0x02), 
                    Offset (0x04), 
                    PSTA,   2
                }

                Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                {
                    Return (SECB) /* \_SB_.PCI0.PEG1.UPSB.SECB */
                }

                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    Return (0x0F)
                }

                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                {
                    Return (0x00)
                }

                Device (DSB0)
                {
                    Name (_ADR, 0x00)  // _ADR: Address
                    OperationRegion (A1E0, PCI_Config, 0x00, 0x40)
                    Field (A1E0, ByteAcc, NoLock, Preserve)
                    {
                        AVND,   32, 
                        BMIE,   3, 
                        Offset (0x18), 
                        PRIB,   8, 
                        SECB,   8, 
                        SUBB,   8, 
                        Offset (0x1E), 
                            ,   13, 
                        MABT,   1
                    }

                    OperationRegion (A1E1, PCI_Config, 0xC0, 0x40)
                    Field (A1E1, ByteAcc, NoLock, Preserve)
                    {
                        Offset (0x01), 
                        Offset (0x02), 
                        Offset (0x04), 
                        Offset (0x08), 
                        Offset (0x0A), 
                            ,   5, 
                        TPEN,   1, 
                        Offset (0x0C), 
                        Offset (0x10), 
                            ,   4, 
                        LDIS,   1, 
                        LRTN,   1, 
                            ,   23, 
                        LACT,   1
                    }

                    OperationRegion (A1E2, PCI_Config, 0x80, 0x08)
                    Field (A1E2, ByteAcc, NoLock, Preserve)
                    {
                        Offset (0x01), 
                        Offset (0x02), 
                        Offset (0x04), 
                        PSTA,   2
                    }

                    Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                    {
                        Return (SECB) /* \_SB_.PCI0.PEG1.UPSB.DSB0.SECB */
                    }

                    Method (_STA, 0, NotSerialized)  // _STA: Status
                    {
                        Return (0x0F)
                    }

                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                    {
                        Return (0x00)
                    }

                    Device (NHI0)
                    {
                        Name (_ADR, 0x00)  // _ADR: Address
                        Name (_STR, Unicode ("Thunderbolt"))  // _STR: Description String
                        Method (_EJ0, 1, NotSerialized)  // _EJx: Eject Device
                        {
                            Debug = "NHI0: Eject method called"
                            If (!OSDW)
                            {
                                Debug = "PLATFORM_ACPI_THUNDERBOLT_ROOT_DEVICE.PSTA ="
                                \_SB.PCI0.PEG1.PSTA = 0x03
                                Debug = "Root Port in D3 state"
                                Debug = "PLATFORM_ACPI_THUNDERBOLT_ROOT_DEVICE.PSTA ="
                                Debug = "PLATFORM_ACPI_THUNDERBOLT_ROOT_DEVICE.LDIS = "
                                \_SB.PCI0.PEG1.LDIS = 0x01
                                Debug = "Set to disable Root Port Link"
                                Debug = "PLATFORM_ACPI_THUNDERBOLT_ROOT_DEVICE.LDIS = "
                                Local0 = (Timer + 0x00989680)
                                While ((Timer <= Local0))
                                {
                                    If ((\_SB.PCI0.PEG1.LACR == 0x01))
                                    {
                                        If ((\_SB.PCI0.PEG1.LACT == 0x00))
                                        {
                                            Debug = "Root Port Link Disabled"
                                            Break
                                        }
                                    }
                                    ElseIf ((\_SB.PCI0.PEG1.UPSB.AVND == 0xFFFFFFFF))
                                    {
                                        Debug = "Root Port Link Disabled"
                                        Break
                                    }

                                    Sleep (0x0A)
                                }

                                GD24 = 0x01
                                Sleep (0x64)
                                Sleep (0x64)
                                Local0 = 0x0A
                                While ((Local0 > 0x00))
                                {
                                    Local0--
                                    Sleep (0x64)
                                    If ((GP24 == 0x00))
                                    {
                                        Debug = "NHI0._EJ0: OK2GO2SX"
                                        Break
                                    }
                                }

                                GP23 = 0x00
                                Sleep (0xFA)
                                Notify (\_SB.PCI0.PEG1, 0x00) // Bus Check
                            }
                        }

                        Name (_GPE, 0x14)  // _GPE: General Purpose Events
                        OperationRegion (A1E0, PCI_Config, 0x00, 0x40)
                        Field (A1E0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   32, 
                            BMIE,   3, 
                            Offset (0x18), 
                            PRIB,   8, 
                            SECB,   8, 
                            SUBB,   8, 
                            Offset (0x1E), 
                                ,   13, 
                            MABT,   1
                        }

                        Method (XRPE, 1, Serialized)
                        {
                            If (OSDW)
                            {
                                If ((Arg0 <= 0x01))
                                {
                                    If ((Arg0 == 0x00))
                                    {
                                        \_SB.PCI0.PEG1.PSTA = 0x03
                                        \_SB.PCI0.PEG1.LDIS = 0x01
                                        Local0 = (Timer + 0x00989680)
                                        While ((Timer <= Local0))
                                        {
                                            If ((\_SB.PCI0.PEG1.LACR == 0x01))
                                            {
                                                If ((\_SB.PCI0.PEG1.LACT == 0x00))
                                                {
                                                    Break
                                                }
                                            }
                                            ElseIf ((\_SB.PCI0.PEG1.UPSB.AVND == 0xFFFFFFFF))
                                            {
                                                Break
                                            }

                                            Sleep (0x0A)
                                        }

                                        \_SB.PCI0.PEG1.CKN1 = 0x01
                                        \_SB.PCI0.PEG1.SQH1 = 0x00
                                        \_SB.PCI0.PEG1.SQH2 = 0x01
                                        GP23 = 0x00
                                    }
                                    Else
                                    {
                                        Local0 = 0x00
                                        If ((GP23 == 0x00))
                                        {
                                            \_SB.PCI0.PEG1.PSTA = 0x00
                                            While (0x01)
                                            {
                                                GP23 = 0x01
                                                Sleep (0x07D0)
                                                Local1 = 0x00
                                                \_SB.PCI0.PEG1.SQH1 = 0x00
                                                \_SB.PCI0.PEG1.SQH2 = 0x00
                                                \_SB.PCI0.PEG1.CKN1 = 0x00
                                                \_SB.PCI0.PEG1.LDIS = 0x00
                                                Local2 = (Timer + 0x00989680)
                                                While ((Timer <= Local2))
                                                {
                                                    If (((\_SB.PCI0.PEG1.LTRN != 0x01) && (\_SB.PCI0.PEG1.UPSB.AVND != 0xFFFFFFFF)))
                                                    {
                                                        Local1 = 0x01
                                                        Break
                                                    }

                                                    Sleep (0x0A)
                                                }

                                                If ((Local1 == 0x01))
                                                {
                                                    MABT = 0x01
                                                    Break
                                                }

                                                If ((Local0 == 0x04))
                                                {
                                                    Return (Zero)
                                                }

                                                Local0++
                                                GP23 = 0x00
                                                Sleep (0x03E8)
                                            }

                                            If ((\_SB.PCI0.PEG1.CSPD == 0x01))
                                            {
                                                If ((\_SB.PCI0.PEG1.SSPD == 0x02))
                                                {
                                                    If ((\_SB.PCI0.PEG1.UPSB.SSPD == 0x02))
                                                    {
                                                        If ((\_SB.PCI0.PEG1.TSPD != 0x02))
                                                        {
                                                            \_SB.PCI0.PEG1.TSPD = 0x02
                                                        }

                                                        If ((\_SB.PCI0.PEG1.UPSB.TSPD != 0x02))
                                                        {
                                                            \_SB.PCI0.PEG1.UPSB.TSPD = 0x02
                                                        }

                                                        \_SB.PCI0.PEG1.LRTN = 0x01
                                                        Local2 = (Timer + 0x00989680)
                                                        While ((Timer <= Local2))
                                                        {
                                                            If (((\_SB.PCI0.PEG1.LTRN != 0x01) && (\_SB.PCI0.PEG1.UPSB.AVND != 0xFFFFFFFF)))
                                                            {
                                                                Local1 = 0x01
                                                                Break
                                                            }

                                                            Sleep (0x0A)
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }

                            Return (Zero)
                        }

                        Method (XRIP, 1, Serialized)
                        {
                            If ((Arg0 <= 0x01))
                            {
                                GI04 = Arg0
                            }
                        }

                        Method (XRIO, 1, Serialized)
                        {
                            If ((Arg0 <= 0x01))
                            {
                                GD04 = Arg0
                            }
                        }

                        Method (XRIL, 0, Serialized)
                        {
                            Return (GP04) /* External reference */
                        }

                        Name (XRIN, 0x14)
                        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                        {
                            If (OSDW)
                            {
                                Local0 = Package (0x03)
                                    {
                                        "power-save", 
                                        0x01, 
                                        Buffer (0x01)
                                        {
                                             0x00                                             // .
                                        }
                                    }
                                DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                                Return (Local0)
                            }

                            Return (Zero)
                        }

                        Method (SXIO, 1, Serialized)
                        {
                            If ((Arg0 <= 0x01))
                            {
                                GD24 = Arg0
                            }
                        }

                        Method (SXIL, 0, Serialized)
                        {
                            Return (GP24) /* External reference */
                        }

                        Method (SXLV, 1, Serialized)
                        {
                            If ((Arg0 <= 0x01))
                            {
                                GP24 = Arg0
                            }
                        }

                        Method (SXFP, 1, Serialized)
                        {
                            If ((Arg0 == 0x00))
                            {
                                GP23 = 0x00
                            }
                        }
                    }
                }

                Device (DSB1)
                {
                    Name (_ADR, 0x00030000)  // _ADR: Address
                    Name (_SUN, 0x02)  // _SUN: Slot User Number
                    OperationRegion (A1E0, PCI_Config, 0x00, 0x40)
                    Field (A1E0, ByteAcc, NoLock, Preserve)
                    {
                        AVND,   32, 
                        BMIE,   3, 
                        Offset (0x18), 
                        PRIB,   8, 
                        SECB,   8, 
                        SUBB,   8, 
                        Offset (0x1E), 
                            ,   13, 
                        MABT,   1
                    }

                    Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                    {
                        Return (SECB) /* \_SB_.PCI0.PEG1.UPSB.DSB1.SECB */
                    }

                    Method (_STA, 0, NotSerialized)  // _STA: Status
                    {
                        Return (0x0F)
                    }

                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                    {
                        Return (0x00)
                    }

                    Device (UPS0)
                    {
                        Name (_ADR, 0x00)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }

                    Device (UPS1)
                    {
                        Name (_ADR, 0x00010000)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }

                    Device (UPS2)
                    {
                        Name (_ADR, 0x00020000)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }

                    Device (UPS3)
                    {
                        Name (_ADR, 0x00030000)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }

                    Device (UPS4)
                    {
                        Name (_ADR, 0x00040000)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }

                    Device (UPS5)
                    {
                        Name (_ADR, 0x00050000)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }

                    Device (UPS6)
                    {
                        Name (_ADR, 0x00060000)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }
                }

                Device (DSB2)
                {
                    Name (_ADR, 0x00040000)  // _ADR: Address
                    Name (_SUN, 0x03)  // _SUN: Slot User Number
                    OperationRegion (A1E0, PCI_Config, 0x00, 0x40)
                    Field (A1E0, ByteAcc, NoLock, Preserve)
                    {
                        AVND,   32, 
                        BMIE,   3, 
                        Offset (0x18), 
                        PRIB,   8, 
                        SECB,   8, 
                        SUBB,   8, 
                        Offset (0x1E), 
                            ,   13, 
                        MABT,   1
                    }

                    Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                    {
                        Return (SECB) /* \_SB_.PCI0.PEG1.UPSB.DSB2.SECB */
                    }

                    Method (_STA, 0, NotSerialized)  // _STA: Status
                    {
                        Return (0x0F)
                    }

                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                    {
                        Return (0x00)
                    }

                    Device (UPS0)
                    {
                        Name (_ADR, 0x00)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }

                    Device (UPS1)
                    {
                        Name (_ADR, 0x00010000)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }

                    Device (UPS2)
                    {
                        Name (_ADR, 0x00020000)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }

                    Device (UPS3)
                    {
                        Name (_ADR, 0x00030000)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }

                    Device (UPS4)
                    {
                        Name (_ADR, 0x00040000)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }

                    Device (UPS5)
                    {
                        Name (_ADR, 0x00050000)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }

                    Device (UPS6)
                    {
                        Name (_ADR, 0x00060000)  // _ADR: Address
                        OperationRegion (ARE0, PCI_Config, 0x00, 0x04)
                        Field (ARE0, ByteAcc, NoLock, Preserve)
                        {
                            AVND,   16
                        }

                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (0x00)
                        }
                    }
                }

                Device (DSB3)
                {
                    Name (_ADR, 0x00050000)  // _ADR: Address
                    Name (_SUN, 0x04)  // _SUN: Slot User Number
                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                    {
                        Return (0x00)
                    }

                    OperationRegion (A1E0, PCI_Config, 0x00, 0x40)
                    Field (A1E0, ByteAcc, NoLock, Preserve)
                    {
                        AVND,   32, 
                        BMIE,   3, 
                        Offset (0x18), 
                        PRIB,   8, 
                        SECB,   8, 
                        SUBB,   8, 
                        Offset (0x1E), 
                            ,   13, 
                        MABT,   1
                    }

                    Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                    {
                        Return (SECB) /* \_SB_.PCI0.PEG1.UPSB.DSB3.SECB */
                    }

                    Method (_STA, 0, NotSerialized)  // _STA: Status
                    {
                        Return (0x0F)
                    }
                }

                Device (DSB4)
                {
                    Name (_ADR, 0x00060000)  // _ADR: Address
                    Name (_SUN, 0x05)  // _SUN: Slot User Number
                    OperationRegion (A1E0, PCI_Config, 0x00, 0x40)
                    Field (A1E0, ByteAcc, NoLock, Preserve)
                    {
                        AVND,   32, 
                        BMIE,   3, 
                        Offset (0x18), 
                        PRIB,   8, 
                        SECB,   8, 
                        SUBB,   8, 
                        Offset (0x1E), 
                            ,   13, 
                        MABT,   1
                    }

                    Method (_BBN, 0, NotSerialized)  // _BBN: BIOS Bus Number
                    {
                        Return (SECB) /* \_SB_.PCI0.PEG1.UPSB.DSB4.SECB */
                    }

                    Method (_STA, 0, NotSerialized)  // _STA: Status
                    {
                        Return (0x0F)
                    }

                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                    {
                        Return (0x00)
                    }
                }

                Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                {
                    If (OSDW)
                    {
                        If ((Arg0 == ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
                        {
                            Local0 = Package (0x02)
                                {
                                    "PCI-Thunderbolt", 
                                    0x01
                                }
                            DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                            Return (Local0)
                        }
                    }

                    Return (Zero)
                }
            }
        }
    }
}

